module addex3( RIN, GIN, BIN, OFT, D3OUT );
input   [3:0]   RIN, GIN, BIN;
input   [2:0]   OFT;
output  [11:0]  D3OUT;

function [3:0] addex;
 input   [3:0] a;
 input   [2:0] b;
 reg     [4:0] temp_sum;
 reg           overflow_flag;
 begin
   temp_sum = a + b;

   overflow_flag = temp_sum[4];

   addex = overflow_flag ? 4'hf : temp_sum[3:0];
 end
endfunction

assign D3OUT[11:8] = addex(RIN,OFT);
assign D3OUT[7:4]  = addex(GIN,OFT);
assign D3OUT[3:0]  = addex(BIN,OFT);

endmodule
