module addsub3_tp;
reg   [3:0]  din0, din1;
reg          mod;
wire  [3:0]  qout;

parameter STEP = 1000;

addsub addsub(
    .DIN0   (din0),
    .DIN1   (din1),
    .MOD    (mod),
    .QOUT   (qout)
);

reg [11:0] mem[0:7];
reg  [3:0] mod_4b;
integer i;

parameter file_name = "addsub_in.dat";

initial begin
    din0 = 0; din1 = 0; mod = 0;
    $readmemh ( file_name, mem );      /*   */
    for (i=0; i<7; i=i+1) begin
        #STEP { din0, din1, mod_4b } = mem[i];  /*   */
              mod = mod_4b[0];
    end
    #STEP   $finish;
end

initial $monitor( $stime, " %d  %b  %d = %d ", din0, mod, din1, qout);

endmodule
