
module bcd60( RES_X, CLK, CNTEN, LSB, MSB, CO );
input	CLK;
input	RES_X;
input	CNTEN;
output	CO;
output	[3:0]	LSB;
output	[2:0]	MSB;

reg	CO;
reg	[3:0]	LSB;
reg	[2:0]	MSB;

always @ (posedge CLK or negedge RES_X) begin
    if (RES_X == 1'b0)
        LSB <= 4'h0;
    else if (CNTEN)
        if (LSB == 4'h9)
            LSB <= 4'h0;
        else
            LSB <= LSB + 4'h1;
end

always @ (posedge CLK or negedge RES_X) begin
    if (RES_X == 1'b0)
        MSB <= 3'h0;
    else if (CNTEN && (LSB == 4'h9))
        if (MSB == 3'h5)
            MSB <= 3'h0;
        else
            MSB <= MSB + 3'h1;
end

always @ (MSB or LSB or CNTEN) begin
    if ((MSB == 3'h5) && (LSB == 4'h9) && CNTEN)
        CO = 1'b1;
    else
        CO = 1'b0;
end

endmodule

