
module decdiv2_tp;
reg             clk, res_x, ld;
reg     [7:0]   din;
wire    [6:0]   dout_led_hi, dout_led_lo, cnt_led;

`include "./led_display.tk"

parameter STEP = 1000;
parameter INITIAL_VALUE = 251;

decdiv2 decdiv2( .CLK(clk), .RES_X(res_x), .LD(ld),
               .DIN(din), .DOUT_LED_HI(dout_led_hi), 
               .DOUT_LED_LO(dout_led_lo), .CNT_LED(cnt_led) );

always begin
    clk = 0; #(STEP/2);
    clk = 1; #(STEP/2);
end

initial begin
            res_x = 1; ld = 0; din = 0;
    #STEP   res_x = 0;
    #STEP   res_x = 1;
    #STEP   din = INITIAL_VALUE;
    #STEP   ld  = 1;
    #STEP   ld  = 0;
    #(STEP*5)
            res_x = 0;
    #STEP   res_x = 1;
    #(STEP*2)
            ld  = 1;
    #(STEP*2)
            ld  = 0;
    #(STEP*18)
            $finish;
end

always @(posedge clk) begin
    $display("DOUT =");
    led_display(dout_led_hi, dout_led_lo, 1'b1);
    $display("CNT =");
    led_display(cnt_led, cnt_led, 1'b0);
end   

initial $monitor( $stime, "  dout=%h %0d  cnt=%0d ", 
                          decdiv2.dout, decdiv2.dout, decdiv2.cnt);
    
endmodule
