
module decdiv_tp;
reg             clk, res_x, ld;
reg     [7:0]   din;
wire    [7:0]   dout;

parameter STEP = 1000;
parameter INITIAL_VALUE = 251;

decdiv decdiv( .CLK(clk), .RES_X(res_x), .LD(ld),
               .DIN(din), .DOUT(dout) );

always begin
    clk = 0; #(STEP/2);
    clk = 1; #(STEP/2);
end

initial begin
            res_x = 1; ld = 0; din = 0;
    #STEP   res_x = 0;
    #STEP   res_x = 1;
    #STEP   din = INITIAL_VALUE;
    #STEP   ld  = 1;
    #STEP   ld  = 0;
    #(STEP*5)
            res_x = 0;
    #STEP   res_x = 1;
    #(STEP*2)
            ld  = 1;
    #(STEP*2)
            ld  = 0;
    #(STEP*18)
            $finish;
end

initial $monitor( $stime, " res_x=%b ld=%b  din=%h %d  dout=%h %d",
                            res_x, ld, din, din, dout, dout );
    
endmodule
