
module decdiv_tp2;
reg             clk, res_x, ld;
reg     [7:0]   din;
wire    [7:0]   dout;

integer         fd;

parameter STEP = 1000;
parameter INITIAL_VALUE = 255;

decdiv decdiv( .CLK(clk), .RES_X(res_x), .LD(ld),
               .DIN(din), .DOUT(dout) );

always begin
    clk = 0; #(STEP/2);
    clk = 1; #(STEP/2);
end

initial begin
            res_x = 1; ld = 0; din = 0;
    #STEP   res_x = 0;
    #STEP   res_x = 1;
    #STEP   din = INITIAL_VALUE;
    #STEP   ld  = 1;
    #STEP   ld  = 0;
    #(STEP*5)
            res_x = 0;
    #STEP   res_x = 1;
    #(STEP*2)
            ld  = 1;
    #(STEP*2)
            ld  = 0;
    #(STEP*18)
            $finish;
end

initial begin
    fd = $fopen( "data_out.dat");
end
    
always @(posedge clk) begin
    $fdisplay(fd, $stime, " %b  %d %b %d", res_x, din, ld, dout);
    $display     ($stime, " %b  %d %b %d", res_x, din, ld, dout);
end

endmodule   
