
module keydisp_tp;
reg     [9:0]   key;
wire            a, b, c, d, e, f, g;

parameter STEP = 1000;

keydisp keydisp( .KEY(key), .A(a), .B(b), .C(c), .D(d), .E(e), .F(f), .G(g) );

initial begin
            key = 0;
    #STEP   key = 10'b00000_00001;  // 0
    #STEP   key = 10'b00000_00010;  // 1
    #STEP   key = 10'b00000_00100;  // 2
    #STEP   key = 10'b00000_01000;  // 3
    #STEP   key = 10'b00000_10000;  // 4
    #STEP   key = 10'b00001_00000;  // 5
    #STEP   key = 10'b00010_00000;  // 6
    #STEP   key = 10'b00100_00000;  // 7 
    #STEP   key = 10'b01000_00000;  // 8
    #STEP   key = 10'b10000_00000;  // 9

    #STEP   key = 10'b00000_00011;  // 0,1
    #STEP   key = 10'b00000_00101;  // 0,2
    #STEP   key = 10'b00000_01000;  // 3
    #STEP   key = 10'b00100_10010;  // 1,4,7
    #STEP   key = 10'b01001_00100;  // 2,5,8
    #STEP   key = 10'b10010_01000;  // 3,6,9
    #STEP   key = 10'b00100_00010;  // 1,7
    #STEP   key = 10'b01000_00100;  // 2,8
    #STEP   key = 10'b10000_01000;  // 3,9
    #STEP   key = 10'b00000_10010;  // 1,4
    #STEP   key = 10'b00001_00100;  // 2,5
    #STEP   key = 10'b00010_00000;  // 6
    #STEP   key = 10'b11100_00000;  // 7,8,9
    #STEP   key = 10'b01110_00000;  // 6,7,8
    #STEP   key = 10'b00111_00000;  // 5,6,7

    #STEP   $finish;
end

initial $monitor( $stime, " key=%b  Seg.=%b%b%b%b%b%b%b", 
                           key, a, b, c, d, e, f, g );

endmodule
