
module keyenc_tp2a;
reg     [9:0]   key;
wire    [3:0]   kout;

parameter STEP = 1000;

parameter HI_Z = 4'hf;
integer i;

keyenc keyenc( .KEY(key), .KOUT(kout) );

initial begin
    key = 10'h000;
    for ( i=1; i<10; i=i+1 )
        keyin2(i-1, i);
    keyin2(9, 6);
    keyin2(8, 5);
    keyin2(9, HI_Z);
    keyin2(7, 4);
    keyin2(6, 3);
    keyin2(5, 2);
    keyin2(HI_Z, 8);
    keyin2(4, 1);
    keyin2(3, 0);
    keyin2(2, 0);
    keyin2(7, HI_Z);
    keyin2(1, 0);

    #STEP  $finish;
end

task keyin2;
input   [3:0] num1, num2;
begin
    if ( num1 != HI_Z )
        key[num1] = 1;
    if ( num2 != HI_Z )
        key[num2] = 1;
    #(STEP/2)  key = 10'h000;
    #(STEP/2) ;
end
endtask

initial $monitor( $stime, " key=%b kout=%d %b", key, kout, kout );

endmodule
