
module saikoro2( CLK, RES_X, EN, LAMP );
input           CLK, RES_X, EN;
output  [6:0]   LAMP;
reg     [6:0]   LAMP;

reg     [6:0]   lamp_next;

always @( posedge CLK or negedge RES_X ) begin
    if ( RES_X==1'b0 )
        LAMP <= 7'b0001000;
    else
        LAMP <= lamp_next;
end

always @( EN or LAMP ) begin
    if ( EN==1'b1 ) 
        case( LAMP )
            7'b1110111 : lamp_next = 7'b0001000;
            7'b0001000 : lamp_next = 7'b1000001;
            7'b1000001 : lamp_next = 7'b0011100;
            7'b0011100 : lamp_next = 7'b1010101;
            7'b1010101 : lamp_next = 7'b1011101;
            7'b1011101 : lamp_next = 7'b1110111;
               default : lamp_next = 7'b0001000;
        endcase
    else
        lamp_next = LAMP;
end

endmodule
