
module saikoro_tp2;
reg             ck, res_x, en;
wire    [6:0]   lamp;

parameter STEP = 1000;

always begin
    ck = 0; #(STEP/2);
    ck = 1; #(STEP/2);
end

saikoro saikoro( .CLK(ck), .RES_X(res_x), .EN(en), .LAMP(lamp) );

initial begin
            res_x = 0; en = 0;
    #STEP   res_x = 1;
    #STEP   en = 1;
    #(STEP*5)
            en = 0;
    #STEP   en = 1;
    #(STEP*12)
            $finish;
end

reg [1*8:1] disp6, disp5, disp4, disp3, disp2, disp1, disp0;

always @( lamp ) begin
     
    if (lamp[6]==1'b1) disp6="@"; else disp6=" ";
    if (lamp[5]==1'b1) disp5="@"; else disp5=" ";
    if (lamp[4]==1'b1) disp4="@"; else disp4=" ";
    if (lamp[3]==1'b1) disp3="@"; else disp3=" ";
    if (lamp[2]==1'b1) disp2="@"; else disp2=" ";
    if (lamp[1]==1'b1) disp1="@"; else disp1=" ";
    if (lamp[0]==1'b1) disp0="@"; else disp0=" ";

    $display("DISPLAY");
    $display(" +-------+");
    $display(" | %c   %c |",  disp0, disp4);
    $display(" | %c %c %c |", disp1, disp3, disp5);
    $display(" | %c   %c |",  disp2, disp6);
    $display(" +-------+");
end

initial $monitor( $stime, " res_x=%b en=%b lamp=%b",
                            res_x, en, lamp );

endmodule
