module decdiv( CLK, RES_X, LD, DIN, DOUT );
input           CLK, RES_X, LD;
input   [7:0]   DIN;
output  [7:0]   DOUT;

reg     [7:0]   DOUT;
reg     [7:0]   DOUT_NEXT;

always @( LD or DIN or DOUT ) begin
    if ( LD )
        DOUT_NEXT = DIN;
    else if ( DOUT[0] )
        DOUT_NEXT = DOUT - 8'h1;
    else
        DOUT_NEXT = DOUT >> 1;
end

always @( posedge CLK or negedge RES_X ) begin
    if ( !RES_X )
        DOUT <= 8'h0;
    else
        DOUT <= DOUT_NEXT;
end

endmodule
