module saikoro( CLK, RES_X, EN, LAMP );
input           CLK, RES_X, EN;
output  [6:0]   LAMP;
reg     [6:0]   LAMP;

reg     [2:0]   cnt;

always @( posedge CLK or negedge RES_X ) begin
    if ( !RES_X )
        cnt <= 3'd1;
    else if ( EN )
        if ( cnt==3'd6 )
            cnt <= 3'd1;
        else
            cnt <= cnt + 3'd1;
end

always @( cnt ) begin
    case( cnt )
        1:  LAMP = 7'b0001000;
        2:  LAMP = 7'b1000001;
        3:  LAMP = 7'b0011100;
        4:  LAMP = 7'b1010101;
        5:  LAMP = 7'b1011101;
        6:  LAMP = 7'b1110111;
  default:  LAMP = 7'bxxxxxxx;
    endcase
end

endmodule
