//
// signal control circuit
//
module sigctrl ( CLK, RST_X, LAMP_R, LAMP_B, LAMP_Y );
input           CLK, RST_X;
output          LAMP_R, LAMP_B, LAMP_Y;
reg             LAMP_R, LAMP_B, LAMP_Y;

reg   [1:0]     CUR_ST;                     //current state
reg   [1:0]     NXT_ST;                     //next state
reg   [3:0]     TIM;
reg             R_END, B_END, Y_END, SYNCR;

parameter       P_RED_ST    = 2'h0;         //red lamp state
parameter       P_BLUE_ST   = 2'h1;         //blue lamp state
parameter       P_YELLOW_ST = 2'h2;         //yellow lamp state

//-----------------------------------------------
// current state FF(2)
// CUR_ST
//-----------------------------------------------







//-----------------------------------------------
// next state combination circuit(1)
// NXT_ST, SYNCR
//-----------------------------------------------













//-----------------------------------------------
// decoder for lamp(3)
// LAMP_R, LAMP_B, LAMP_Y
//-----------------------------------------------










//-----------------------------------------------
// timer
//-----------------------------------------------
always @( posedge CLK or negedge RST_X ) begin
    if ( RST_X == 1'b0 )
        TIM <= 4'h0;
    else if ( SYNCR == 1'b1 )
        TIM <= 4'h0;
    else
        TIM <= TIM + 4'h1;
end

//-----------------------------------------------
// decoder for light out time
//-----------------------------------------------
always @( TIM ) begin
    if ( TIM == 4'd2 ) begin
        R_END = 1'b0;
        B_END = 1'b0;
        Y_END = 1'b1;
    end
    else if ( TIM == 4'd9 ) begin
        R_END = 1'b1;
        B_END = 1'b0;
        Y_END = 1'b0;
    end
    else if ( TIM == 4'd14 ) begin
        R_END = 1'b0;
        B_END = 1'b1;
        Y_END = 1'b0;
    end
    else begin
        R_END = 1'b0;
        B_END = 1'b0;
        Y_END = 1'b0;
    end
end

endmodule
